/*
Crafter® Build
Copyright (C) 2026 Catcrafts®
Catcrafts.net

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License version 3.0 as published by the Free Software Foundation;

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
*/

module Crafter.Build:Implementation_impl;
import std;
import :Implementation;
import :Module;
import :Command;
namespace fs = std::filesystem;

namespace Crafter {
    Implementation::Implementation(fs::path&& path) : path(std::move(path)) {

    }
    bool Implementation::Check(const fs::path& buildDir, const fs::path& pcmDir) const {
        if(fs::exists((buildDir/path.filename()).string()+"_impl.o") && fs::last_write_time(path.string()+".cpp") < fs::last_write_time((buildDir/path.filename()).string()+"_impl.o")) {
            for(ModulePartition* dependency : partitionDependencies) {
                if(dependency->Check(pcmDir)) {
                    return true;
                }
            }
            for(Module* dependency : moduleDependencies) {
                if(dependency->Check(pcmDir)) {
                    return true;
                }
            }
            return false;
        } else {
            return true;
        }
    }
    void Implementation::Compile(const std::string_view clang, const fs::path& buildDir, std::string& result) const {
        for(ModulePartition* dependency : partitionDependencies) {
            if(!dependency->compiled.load()) {
                dependency->compiled.wait(CRAFTER_COMPILE_STATUS_WAITING);
                if(dependency->compiled.load() == CRAFTER_COMPILE_STATUS_ERROR) {
                    return;
                }
            }
        }
        for(Module* dependency : moduleDependencies) {
            if(!dependency->compiled.load()) {
                dependency->compiled.wait(CRAFTER_COMPILE_STATUS_WAITING);
                if(dependency->compiled.load() == CRAFTER_COMPILE_STATUS_ERROR) {
                    return;
                }
            }
        }
        result = RunClang(std::format("{} {}.cpp -c -o {}_impl.o", clang, path.string(), (buildDir/path.filename()).string()));
    }
}
